@echo off
setlocal enabledelayedexpansion

REM landscape image width
set landsmall=400
set landmedium=800
set landlarge=1200
REM portrait image width
set portsmall=265
set portmedium=530
set portlarge=795

if not exist %1\NUL (
REM parameter is not a folder, so loop over each given parameter
	call :MKRESDIR %~dp1
	:LOOP
	if "%1" == "" (
		goto :END
	)
	if "%~x1" == ".jpg"  (
		set pathnow=%~dp1
		call :DECIDE %~nx1
	)
	if "%~x1" == ".jpeg"  (
		set pathnow=%~dp1
		call :DECIDE %~nx1
	)
	SHIFT
	goto :LOOP
) else (
REM parameter is a folder, loop over every *.jpg in it
	:LOOP2
	if "%1" == "" (
		goto :END
	)
	set pathnow=%1
	call :MKRESDIR %1
	for /f %%f in ('dir /b %1\*.jp*g') do (
		call :DECIDE %%f
	)
	SHIFT
	goto :LOOP2
)
goto :END

REM MaKe RESize DIRectory - creates a unique (?) folder for resized images
REM call :MKRESDIR Parentfolder
:MKRESDIR
	if not exist "%1\resize" (
		mkdir %1\resize
		set resdir=resize
	) else (
		set resdir=resize-%time:~0,2%_%time:~3,2%_%time:~6,2%
		mkdir %1\!resdir!
	)
	goto :EOF

REM DECIDE - checks wether landscape or portrait and calls :CONIMGS
REM call :DECIDE file
:DECIDE
	echo Working on file %1...
	for /f "delims=" %%a in ('identify -format %%h %pathnow%\%1') do @set height=%%a
	for /f "delims=" %%a in ('identify -format %%w %pathnow%\%1') do @set width=%%a
	if !height! LEQ !width! (
		call :CONIMGS %pathnow%\%1 %landsmall% small
		call :CONIMGS %pathnow%\%1 %landmedium% medium
		call :CONIMGS %pathnow%\%1 %landlarge% large
		echo.
	) else (
		call :CONIMGS %pathnow%\%1 %portsmall% small
		call :CONIMGS %pathnow%\%1 %portmedium% medium
		call :CONIMGS %pathnow%\%1 %portlarge% large
		echo.
	)
	goto :EOF

REM CONvert IMaGe Single - calls imageMagick to resize the given image
REM call :CONIMGS file pixelwidth suffix
:CONIMGS
	echo|set /p dummy=%2 (%3) px...	
	convert %1 -filter Triangle -define filter:support=2 -thumbnail %2 -unsharp 0.25x0.08+8.3+0.045 -dither None -posterize 136 -quality 82 -define jpeg:fancy-upsampling=off -define png:compression-filter=5 -define png:compression-level=9 -define png:compression-strategy=1 -interlace none -colorspace sRGB %~dp1%resdir%\%~n1-%3%~x1
	goto :EOF

:END
pause
exit 